package hk.edu.hkbu.comp.maw2013.attendancerecord;

import java.util.ArrayList;

import org.apache.http.HttpResponse;
import org.apache.http.NameValuePair;
import org.apache.http.client.entity.UrlEncodedFormEntity;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.message.BasicNameValuePair;
import org.apache.http.protocol.HTTP;
import org.apache.http.util.EntityUtils;

import android.os.AsyncTask;
import android.os.Bundle;
import android.support.v4.app.Fragment;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Toast;

public class SubmitFragment extends Fragment {
	
	private EditText studentNameEt;
	private EditText courseCodeEt;
	private Button submitBtn;
	
	@Override
	public View onCreateView(LayoutInflater inflater, ViewGroup container,
			Bundle savedInstanceState) {
		View view = inflater.inflate(R.layout.fragment_submit, container, false);
		return view;
	}
	
	@Override
	public void onActivityCreated(Bundle savedInstanceState){
		super.onActivityCreated(savedInstanceState);
		studentNameEt = (EditText)getView().findViewById(R.id.editTextStudentName);
		courseCodeEt = (EditText)getView().findViewById(R.id.editTextCourseCode);
		submitBtn = (Button)getView().findViewById(R.id.buttonSubmit);
		
		submitBtn.setOnClickListener(new OnClickListener(){
			@Override
			public void onClick(View v) {
				new SubmitTask().execute(new String[]{studentNameEt.getText().toString(), courseCodeEt.getText().toString()});
				
			}});
	}
	
	private class SubmitTask extends AsyncTask<String, Void, String> {
		@Override
		protected String doInBackground(String... arg) {
			String response = "";
			
			HttpPost request = new HttpPost("http://cs9206.comp.hkbu.edu.hk/maw_2013/attendance/submit_att.php");
			ArrayList<NameValuePair> params = new ArrayList<NameValuePair>();
			params.add(new BasicNameValuePair("student_name", arg[0]));
			params.add(new BasicNameValuePair("course_code", arg[1]));
			
			try {
				request.setEntity(new UrlEncodedFormEntity(params, HTTP.UTF_8));
				HttpResponse httpResponse = new DefaultHttpClient().execute(request);
				if(httpResponse.getStatusLine().getStatusCode() == 200){
					response = EntityUtils.toString(httpResponse.getEntity());
				}else{
					response = "Error, Status Code: " + httpResponse.getStatusLine().getStatusCode();
					Log.e("Error", "Status Code: " + httpResponse.getStatusLine().getStatusCode());
				}
			} catch (Exception e) {
				e.printStackTrace();
			}
			return response;
		}
		
		@Override
		protected void onPostExecute(String result){
			Toast.makeText(getActivity(), result, Toast.LENGTH_SHORT).show();
		}
	}
}